`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:19:06 02/25/2020 
// Design Name: 
// Module Name:    key_delay 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module key_delay(
	input      		clk    ,
	input   			rst_n  ,
	input   [3:0]  key_in ,
	output  [3:0]  key_done
    );
	 
parameter   TIME_20MS = 1_000_000;     //20ms消抖(50M/50=1000000)

reg [ 3:0]  key_ff0   ;
reg [ 3:0]  key_ff1   ;
reg [19:0]  delay_cnt ;
reg [ 3:0]  key_scan  ;
reg [ 3:0]  key_scan_r;
wire        add_delay_cnt;
wire        end_delay_cnt;

always @(posedge clk or negedge rst_n)        
begin
   if(!rst_n)begin
		key_in <= 4'b1111;
	end
	else begin
	   key_ff0 <= key_in;
		key_ff1 <= key_ff0;
	end
end

always @(posedge clk or negedge rst_n)        
begin
   if(!rst_n)begin
		delay_cnt <= 20'd0;
	end
	else if(add_delay_cnt)begin
		if(end_delay_cnt)
			delay_cnt <= 20'd0;
		else 
			delay_cnt <= delay_cnt + 1;
	end
	else 
		delay_cnt <= 20'd0;
end
assign add_delay_cnt = 1;
assign end_delay_cnt = add_delay_cnt&&delay_cnt==TIME_20MS-1;

always @(posedge clk or negedge rst_n)        
begin
   if(!rst_n)begin
		key_scan <= 4'b1111;
	end
	else if(end_delay_cnt)
		key_scan <= key_ff1;
   else 
	   key_scan <= key_scan;
end
		   
always @(posedge clk or negedge rst_n)
begin
	if(!rst_n)begin
		key_scan_r <= 4'b1111;
	end
	else begin
		key_scan_r <= key_scan;
	end
end 
  
assign key_done = key_scan_r & (~key_scan);  

endmodule

